# Copyright or © or Copr. Loïc Paulevé (2023)
#
# loic.pauleve@cnrs.fr
#
# This software is governed by the CeCILL license under French law and
# abiding by the rules of distribution of free software.  You can  use,
# modify and/ or redistribute the software under the terms of the CeCILL
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info".
#
# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability.
#
# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or
# data to be ensured and,  more generally, to use and operate it in the
# same conditions as regards security.
#
# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL license and that you accept its terms.
#

import itertools

def matching_configurations(obs):
    bo = obs.mgr.bo
    nodes = list(bo.domain)
    mutations = set(obs.mgr.mutations if hasattr(obs.mgr, "mutations") else [])
    known = mutations.union(bo.data[obs.name])
    missing = [n for n in nodes if n not in known]
    for assigns in itertools.product((0,1), repeat=len(missing)):
        cfg = +obs
        for (n, b) in zip(missing, assigns):
            cfg[n] = b
        yield cfg

def bn_nocyclic_attractors(bn):
    return not bn.has_cyclic_attractor()

def all_different(cfgs):
    for a, b in itertools.combinations(cfgs, 2):
        a != b
